function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {};
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);
    if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(object);
        if (enumerableOnly) {
            symbols = symbols.filter(function(sym) {
                return Object.getOwnPropertyDescriptor(object, sym).enumerable;
            });
        }
        keys.push.apply(keys, symbols);
    }
    return keys;
}
function _objectSpreadProps(target, source) {
    source = source != null ? source : {};
    if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
        ownKeys(Object(source)).forEach(function(key) {
            Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
    }
    return target;
}
import path from "path";
import { createMatchPath } from "@modern-js/utils/tsconfig-paths";
import { getUserAlias } from "@modern-js/utils";
var resolvePath = require("babel-plugin-module-resolver").resolvePath;
var defaultPaths = {
    "@": [
        "./src"
    ]
};
var aliasPlugin = function(alias) {
    var absoluteBaseUrl = alias.absoluteBaseUrl, isTsPath = alias.isTsPath, _isTsProject = alias.isTsProject, isTsProject = _isTsProject === void 0 ? false : _isTsProject;
    var mergedPaths = isTsPath ? alias.paths || {} : _objectSpread({}, defaultPaths, alias.paths || {});
    var tsPaths = {};
    if (isTsProject) {
        tsPaths = getUserAlias(mergedPaths);
    }
    tsPaths = Object.keys(tsPaths).reduce(function(o, key) {
        if (typeof tsPaths[key] === "string") {
            return _objectSpreadProps(_objectSpread({}, o), _defineProperty({}, "".concat(key), [
                tsPaths[key]
            ]));
        }
        return _objectSpreadProps(_objectSpread({}, o), _defineProperty({}, "".concat(key), tsPaths[key]));
    }, {});
    var resolvePathFn = function(sourcePath, currentFile, opts) {
        if (sourcePath === "." || sourcePath === "./") {
            return sourcePath;
        }
        var matchPath = createMatchPath(absoluteBaseUrl, tsPaths, [
            "index"
        ]);
        var result = matchPath(sourcePath, void 0, void 0, [
            ".js",
            ".jsx",
            ".ts",
            ".tsx"
        ]);
        if (result) {
            var relativePath = path.relative(path.dirname(currentFile), path.dirname(result));
            var fileName = path.basename(result);
            var filePath = path.normalize("".concat(relativePath.length === 0 ? "." : relativePath, "/").concat(fileName)).replace(/\\/, "/");
            return filePath.startsWith(".") ? filePath : "./".concat(filePath);
        }
        return resolvePath(sourcePath, currentFile, opts);
    };
    var typescriptExts = [
        ".ts",
        ".tsx",
        ".js",
        ".jsx",
        ".es",
        ".es6",
        ".mjs"
    ];
    return [
        "babel-plugin-module-resolver",
        {
            root: absoluteBaseUrl,
            alias: mergedPaths,
            resolvePath: isTsPath ? resolvePathFn : void 0,
            extensions: isTsProject ? typescriptExts : void 0
        }
    ];
};
export { aliasPlugin };
